=== plugins/demo/CMakeLists.txt ===
INCLUDE(BuildVeyonPlugin)

build_veyon_plugin(demo
	DemoFeaturePlugin.cpp
	DemoConfigurationPage.cpp
	DemoConfigurationPage.ui
	DemoServer.cpp
	DemoServerConnection.cpp
	DemoServerProtocol.cpp
	DemoClient.cpp
	DemoFeaturePlugin.h
	DemoConfiguration.h
	DemoConfigurationPage.h
	DemoServer.h
	DemoServerConnection.h
	DemoServerProtocol.h
	DemoClient.h
	demo.qrc
)

TARGET_LINK_LIBRARIES(demo ${LZO_LIBRARIES})
