=== plugins/vncserver/headless/CMakeLists.txt ===
include(BuildVeyonPlugin)

find_package(LibVNCServer 0.9.8)

if(LibVNCServer_FOUND)

build_veyon_plugin(headless-vnc-server
	HeadlessVncServer.cpp
	HeadlessVncServer.h
	HeadlessVncConfiguration.h
)

target_link_libraries(headless-vnc-server LibVNC::LibVNCServer)

target_compile_options(headless-vnc-server PRIVATE -Wno-parentheses)

endif()
