=== debian/changelog ===
veyon (4.5.7-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 12 Aug 2021 13:27:01 -0400

veyon (4.5.7-1~hirsute) hirsute; urgency=medium

  * Upload to Hirsute

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 06 Aug 2021 08:54:53 +0200

veyon (4.5.7-1~groovy) groovy; urgency=medium

  * Upload to Groovy

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 06 Aug 2021 08:54:09 +0200

veyon (4.5.7-1~bionic) bionic; urgency=medium

  * Upload to Bionic

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 06 Aug 2021 08:53:41 +0200

veyon (4.5.7-1~xenial) xenial; urgency=medium

  * Upload to Xenial

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 06 Aug 2021 08:53:04 +0200

veyon (4.5.7-1~focal) focal; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 06 Aug 2021 08:45:13 +0200

veyon (4.5.5-1~groovy) groovy; urgency=medium

  * Upload to Groovy

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 21 Apr 2021 09:05:13 +0200

veyon (4.5.5-1~bionic) bionic; urgency=medium

  * Upload to Bionic

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 21 Apr 2021 09:04:44 +0200

veyon (4.5.5-1~xenial) xenial; urgency=medium

  * Upload to Xenial

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 21 Apr 2021 09:04:14 +0200

veyon (4.5.5-1~focal) focal; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 21 Apr 2021 09:03:06 +0200

veyon (4.5.4-1~groovy) groovy; urgency=medium

  * Upload to Groovy

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 12 Mar 2021 10:19:46 +0100

veyon (4.5.4-1~bionic) bionic; urgency=medium

  * Upload to Bionic

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 12 Mar 2021 10:19:19 +0100

veyon (4.5.4-1~xenial) xenial; urgency=medium

  * Upload to Xenial

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 12 Mar 2021 10:18:54 +0100

veyon (4.5.4-1~focal) focal; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 12 Mar 2021 09:55:07 +0100

veyon (4.5.3-1~focal) focal; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 16 Feb 2021 09:35:15 +0100

veyon (4.5.2-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 23 Dec 2020 19:48:48 +0100

veyon (4.5.1-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 25 Nov 2020 11:08:32 +0100

veyon (4.5.0-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Mon, 16 Nov 2020 10:30:11 +0100

veyon (4.4.2-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 02 Sep 2020 20:25:35 +0200

veyon (4.4.1-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Thu, 09 Jul 2020 10:29:50 +0200

veyon (4.3.5-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Fri, 24 Apr 2020 12:21:27 +0200

veyon (4.3.3-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Mon, 10 Feb 2020 10:08:25 +0100

veyon (4.3.2-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 29 Jan 2020 09:27:56 +0100

veyon (4.3.0-1~bionic) bionic; urgency=medium

  * New upstream release
  * Add libfakekey-dev dependency

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 15 Oct 2019 10:13:29 +0200

veyon (4.2.5-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 18 Sep 2019 10:02:24 +0200

veyon (4.2.4-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Thu, 01 Aug 2019 11:38:58 +0200

veyon (4.2.3-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 02 Jul 2019 16:47:09 +0200

veyon (4.2.2-1~bionic) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Thu, 23 May 2019 09:57:21 +0200

veyon (4.2.0-1) bionic; urgency=medium

  * New upstream release
  * Add new build dependency libsasl2-dev

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 30 Apr 2019 16:34:34 +0200

veyon (4.1.8-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Thu, 04 Apr 2019 17:10:38 +0200

veyon (4.1.7-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 30 Jan 2019 15:28:01 +0100

veyon (4.1.6-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 19 Dec 2018 10:23:27 +0100

veyon (4.1.5-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Mon, 26 Nov 2018 09:32:28 +0100

veyon (4.1.4-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 09 Oct 2018 19:49:01 +0200

veyon (4.1.3-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Wed, 03 Oct 2018 11:24:16 +0200

veyon (4.1.2-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Thu, 13 Sep 2018 09:33:44 +0200

veyon (4.1.1-1) bionic; urgency=medium

  * New upstream release

 -- Tobias Junghans <tobydox@veyon.io>  Tue, 07 Aug 2018 18:26:33 +0200

veyon (4.1.0-1) bionic; urgency=medium

  * Initial release

 -- Tobias Junghans <tobydox@veyon.io>  Sun, 05 Aug 2018 19:08:39 +0200
