=== debian/control ===
Source: veyon
Section: education
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Tobias Junghans <tobydox@veyon.io>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.5),
               git,
               cmake,
               qtbase5-dev,
               qtbase5-private-dev,
               qtbase5-dev-tools,
               qttools5-dev,
               qttools5-dev-tools,
               xorg-dev,
               libvncserver-dev,
               libfakekey-dev,
               libjpeg-dev,
               zlib1g-dev,
               libssl-dev,
               libpam0g-dev,
               libprocps-dev,
               libldap2-dev,
               libsasl2-dev,
               libpng-dev,
               liblzo2-dev,
               libqca-qt5-2-dev
Standards-Version: 4.1.4
Homepage: https://veyon.io

Package: veyon
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libqca-qt5-2-plugins
Description: Veyon - Virtual Eye On Networks
